Index: apps/app_dial.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_dial.c,v
retrieving revision 1.94.2.6
diff -u -r1.94.2.6 app_dial.c
--- apps/app_dial.c	27 Feb 2005 01:40:43 -0000	1.94.2.6
+++ apps/app_dial.c	28 Mar 2005 10:39:50 -0000
@@ -73,6 +73,7 @@
 "      'C' -- reset call detail record for this call.\n"
 "      'P[(x)]' -- privacy mode, using 'x' as database if provided.\n"
 "      'g' -- goes on in context if the destination channel hangs up\n"
+"      'E' -- disable echo cancellation.\n"
 "      'A(x)' -- play an announcement to the called party, using x as file\n"
 "      'S(x)' -- hangup the call after x seconds AFTER called party picked up\n"  	
 "      'D([digits])'  -- Send DTMF digit string *after* called party has answered\n"
@@ -110,6 +111,7 @@
 	int allowredirect_out;
 	int ringbackonly;
 	int musiconhold;
+	int disableechocan;
 	int allowdisconnect_in;
 	int allowdisconnect_out;
 	int forcecallerid;
@@ -504,7 +506,6 @@
 	
 
 	if (transfer) {
-
 		/* Extract call duration limit */
 		if ((cdl = strstr(transfer, "S("))) {
 			calldurationlimit=atoi(cdl+2);
@@ -707,6 +708,14 @@
 		}
 		memset(tmp, 0, sizeof(struct localuser));
 		if (transfer) {
+			if (strchr(transfer, 'E')) {
+				tmp->disableechocan = 1;
+				if (option_verbose > 2)
+					ast_verbose(VERBOSE_PREFIX_3 "DIAL: Disabled echo cancellation\n");
+			} else {
+				tmp->disableechocan = 0;
+			}
+
 			if (strchr(transfer, 't'))
 				tmp->allowredirect_in = 1;
                         else    tmp->allowredirect_in = 0;
@@ -908,6 +917,13 @@
 		   conversation.  */
 		hanguptree(outgoing, peer);
 		outgoing = NULL;
+
+		/* Get rid of echocancellation if requested */
+		if (tmp->disableechocan) {
+		    char x=0;
+		    ast_channel_setoption(peer,AST_OPTION_AUDIO_MODE,&x,1,0);
+		}
+
 		/* If appropriate, log that we have a destination channel */
 		if (chan->cdr)
 			ast_cdr_setdestchan(chan->cdr, peer->name);
